Cdio447/Areas/Admin/Controllers/TransactionHistoryController.cs
using Cdio447.Areas.Admin.Models;
using Cdio447.Models;
using PagedList;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace Cdio447.Areas.Admin.Controllers
{
    public class TransactionHistoryController : CheckloginController
    {

        private DBContext db;

        public TransactionHistoryController()
        {
            db = new DBContext();
        }

        // GET: Admin/TransactionHistory
        public ActionResult Index()
        {
            return View();
        }

        //GET: Admin/Recharge
        public ActionResult Recharge(string searchString, int page = 1, int pageSize = 12)
        {
            IEnumerable<payinto_histories_View> list = (from a in db.payinto_histories
                                                        join b in db.users
                                                        on a.user_id equals b.id
                                                        join c in db.banks
                                                        on a.bank_id equals c.id
                                                        select new
                                                        {
                                                            user_name = b.user_name,
                                                            bank = c.name,
                                                            amount = a.amount,
                                                            oder_code = a.oder_code,
                                                            created_at = a.created_at
                                                        }).Select(u => new payinto_histories_View()
                                                        {
                                                            user_name = u.user_name,
                                                            bank = u.bank,
                                                            amount = (int)u.amount,
                                                            oder_code = u.oder_code,
                                                            created_at = u.created_at
                                                        });
            if (!string.IsNullOrEmpty(searchString))
            {
                list = list.Where(u => u.user_name.Contains(searchString));
            }
            list = list.ToList().ToPagedList(page, pageSize);
            return View(list);
        }

        //GET: Admin/Withdrawl
        public ActionResult Withdrawl(string searchString, short? status, int page = 1, int pageSize = 12)
        {
            IEnumerable<withdrawl_histories_View> list = (from a in db.withdrawl_histories
                                                          join b in db.users
                                                          on a.user_id equals b.id
                                                          join c in db.payment_gateways
                                                          on a.user_id equals c.user_id
                                                          select new
                                                          {
                                                              id = a.id,
                                                              user_name = b.user_name,
                                                              account_name = c.account_name,
                                                              account_code = c.account_code,
                                                              total = a.total,
                                                              status = a.status,
                                                              created_at = a.created_at.ToString()
                                                          }).Select(u => new withdrawl_histories_View()
                                                          {
                                                              id = u.id,
                                                              user_name = u.user_name,
                                                              account_name = u.account_name,
                                                              account_code = u.account_code,
                                                              total = (int)u.total,
                                                              status = u.status,
                                                              created_at = u.created_at
                                                          });
            if (!string.IsNullOrEmpty(searchString))
            {
                list = list.Where(u => u.user_name.Contains(searchString));
            }
            if (status == 1 || status == 2)
            {
                list = list.Where(u => u.status == status);
            }
            else
            {
                list = list.ToList().ToPagedList(page, pageSize);
            }
            list = list.ToList().ToPagedList(page, pageSize);
            return View(list);
        }

        [HttpPost]
        public JsonResult changeStatus(int id)
        {
            var data = change(id);
            return Json(new
            {
                status = data
            });
        }

        public short? change(int id)
        {
            var user = db.withdrawl_histories.Find(id);
            if (user.status != 2)
            {
                user.status = 2;
            }
            else
            {
                user.status = 1;
            }
            db.SaveChanges();
            return user.status;
        }

        
    }
}

Cdio447/Controllers/WithdrawlController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Cdio447.Models;
using Cdio447.Code;
using Cdio447.ViewModels;

namespace Cdio447.Controllers
{
    public class WithdrawlController : Controller
    {
        private DBContext db = new DBContext();
        // GET: Withdrawl
        public ActionResult PaymentGateway()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var banks = db.banks.ToList();
                ViewBag.banks = banks;
                ViewBag.success = null;
                ViewBag.CheckModel = "";
                var model = db.payment_gateways.Find(session.User_id);
                if(model == null)
                {
                    ViewBag.CheckModel = null;
                }
                return View(model);
            }
            return RedirectToAction("Login", "Login");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult PaymentGateway(payment_gateways pw)
        {
            var banks = db.banks.ToList();
            ViewBag.banks = banks;
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                pw.user_id = session.User_id;
                if (ModelState.IsValid)
                {
                    if(pw.bank_id == 0)
                    {
                        ModelState.AddModelError("bank_id", "Vui lòng chọn cổng thanh toán");
                    } else
                    {
                        payment_gateways getPW = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                        if (getPW == null)
                        {
                            db.payment_gateways.Add(pw);
                            db.SaveChanges();
                            ViewBag.success = "";
                        }
                        else
                        {
                            getPW.bank_id = pw.bank_id;
                            getPW.account_code = pw.account_code;
                            getPW.account_name = pw.account_name;
                            ViewBag.success = "";
                            db.SaveChanges();
                        }
                    }
                }
                return View(pw);
            }
            return RedirectToAction("Login", "Login");
        }
        [HttpGet]
        public ActionResult Withdrawl()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var pwModel = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                ViewBag.pwModel = pwModel;
                var getWH = db.withdrawl_histories.Where(x => x.user_id == session.User_id).ToList();
                ViewBag.CheckModel = "";
                ViewBag.CheckHistory = null;
                ViewBag.amountAble = getAmountAble();
                if (pwModel == null)
                    ViewBag.CheckModel = null;
                if (getWH != null)
                    ViewBag.CheckHistory = getWH;
                return View();
            }
            return RedirectToAction("Login", "Login");
        }

        [HttpPost]
        public ActionResult Withdrawl(WidthdrawlViewModel wd)
        {
            
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            if (session != null)
            {
                var pwModel = db.payment_gateways.SingleOrDefault(x => x.user_id == session.User_id);
                ViewBag.pwModel = pwModel;
                var getWH = db.withdrawl_histories.Where(x => x.user_id == session.User_id).ToList();
                ViewBag.CheckModel = "";
                ViewBag.CheckHistory = null;
                ViewBag.amountAble = getAmountAble();
                decimal currentMoney = (decimal)pwModel.users.current_money;
                if (pwModel == null)
                    ViewBag.CheckModel = null;
                if (getWH != null)
                    ViewBag.CheckHistory = getWH;
                if (ModelState.IsValid)
                {
                    decimal convert = decimal.Parse(wd.amount);
                    if ((convert % 50000) != 0)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải là bội số của 50,000");
                    } else if(convert <= 250000)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải lớn hơn hoặc bằng 250,000 VND");
                    } else if (convert > currentMoney)
                    {
                        ModelState.AddModelError("amount", "Số tiền rút phải nhỏ hơn số tiền hiện có");
                    } else
                    {
                        withdrawl_histories newWd = new withdrawl_histories();
                        string datetime = DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss");
                        DateTime date = DateTime.ParseExact(datetime, "dd/MM/yyyy HH:mm:ss", null);
                        newWd.user_id = session.User_id;
                        newWd.total = convert;
                        newWd.status = 1;//dang xu ly
                        newWd.created_at = date;
                        db.withdrawl_histories.Add(newWd);
                        users user = db.users.Find(session.User_id);
                        user.current_money = user.current_money - convert;
                        db.SaveChanges();
                        ViewBag.success = "";
                    }
                }
                return View(wd);
            }
            return RedirectToAction("Login", "Login");
        }

        public decimal getAmountAble()
        {
            var session = (UserSession)Session[CommonConstants.USER_SESSION];
            var pwModel = db.users.SingleOrDefault(x => x.id == session.User_id);
            decimal currentMoney = (decimal)pwModel.current_money;
            decimal amountAble = 0;
            if (currentMoney >= 250000)
            {
                amountAble = currentMoney - 50000;
            }
            return amountAble;
        }
    }
}

Cdio447/Areas/Admin/Views/TransactionHistory/Recharge.cshtml
@model PagedList.IPagedList<Cdio447.Areas.Admin.Models.payinto_histories_View>
@using PagedList.Mvc;
@{
    ViewBag.Title = "Lịch sử nạp tiền";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
<div class="form-row align-items-center mb-1">
    <div class="col-12 col-lg-auto">
        <input type="button" class="btn btn_template" value="Lịch sử nạp tiền" onclick="location.href='@Url.Action("Recharge","TransactionHistory")'" />
    </div>
    <div class="col-12 col-lg-auto">
        <input type="button" class="btn btn_template" value="Lịch sử rút tiền" onclick="location.href='@Url.Action("Withdrawl","TransactionHistory")'" />
    </div>
</div>
<div class="box-title-section">
    <h1 class="m-0">Danh sách giao dịch nạp tiền</h1>
</div>
@using (Html.BeginForm("Withdrawl", "TransactionHistory", FormMethod.Get))
{
    <div class="form-row align-items-center mb-1">
        <div class="col-12 col-lg-auto">
            <input type="text" value="@ViewBag.SearchString" class="form-control" name="searchString" placeholder="Nhập tên user" />
        </div>
        <div class="col-12 col-lg-auto">
            <button class="btn btn-primary" type="submit" id="btnSearch">Tìm kiếm</button>
        </div>
    </div>
}
<div class="table-box">
    <table class="table table-bordered">
        <thead>
            <tr>
                <th>
                    User
                </th>
                <th>
                    Ngân hàng
                </th>
                <th>
                    Số tiền nạp
                </th>
                <th>
                    Mã giao dịch
                </th>
                <th>
                    Ngày thực hiện
                </th>
            </tr>
        </thead>

        <tbody id="tblData">
            @foreach (var item in Model)
            {
                <tr>
                    <td>@item.user_name</td>
                    <td>@item.bank</td>
                    <td>@item.amount</td>
                    <td>@item.oder_code</td>
                    <td>@item.created_at</td>
                </tr>
            }
        </tbody>
    </table>
    <div>
        @Html.PagedListPager(Model, page => Url.Action("Withdrawl", new { page, @searchString = @ViewBag.SearchString, @status = @ViewBag.status }))
    </div>
</div>

Cdio447/Areas/Admin/Views/TransactionHistory/Withdrawl.cshtml
@model PagedList.IPagedList<Cdio447.Areas.Admin.Models.withdrawl_histories_View>
@using PagedList.Mvc;
@using Cdio447.Supports;
@{
    ViewBag.Title = "Lịch sử rút tiền";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section jsFooter{
    <script src="~/Content/assets/admin/js/controller/transactionHistoryController.js"></script>
}
<div class="form-row align-items-center mb-1">
    <div class="col-12 py-2 py-lg-0 col-lg-auto">
        <input type="button" class="btn btn_template" value="Lịch sử nạp tiền" onclick="location.href='@Url.Action("Recharge","TransactionHistory")'" />
    </div>
    <div class="col-12 py-2 py-lg-0 col-lg-auto">
        <input type="button" class="btn btn_template" value="Lịch sử rút tiền" onclick="location.href='@Url.Action("Withdrawl","TransactionHistory")'" />
    </div>
</div>
<div class="box-title-section">
    <h1 class="m-0">Danh sách giao dịch rút tiền</h1>
</div>
@using (Html.BeginForm("Withdrawl", "TransactionHistory", FormMethod.Get))
{
    <div class="form-row align-items-center">
        <div class="col-12 py-2 py-lg-0 col-lg-auto">
            <input type="text" value="@ViewBag.SearchString" class="form-control" name="searchString" placeholder="Nhập tên user" />
        </div>
        <div class="col-12 py-2 py-lg-0 col-lg-auto">
            @Html.DropDownList("status", new List<SelectListItem>{
                new SelectListItem { Text="All", Value="0"},
                new SelectListItem { Text="Đã thanh toán", Value="2"},
                new SelectListItem { Text="Chưa thanh toán", Value="1"}}, new { @class = "form-control h-auto" })
        </div>
        <div class="col-12 col-lg-auto">
            <button class="btn btn-primary" type="submit" id="btnSearch">Tìm kiếm</button>
        </div>
    </div>
}
<div class="table-box">
    <table class="table table-bordered">
        <thead>
            <tr>
                <th hidden>id</th>
                <th>
                    User
                </th>
                <th>
                    Tên chủ tài khoản
                </th>
                <th>
                    Số tài khoản
                </th>
                <th>
                    Tổng tiền rút
                </th>
                <th>
                    Trạng thái
                </th>
                <th>
                    Ngày thực hiện
                </th>
            </tr>
        </thead>

        <tbody id="tblData">
            @foreach (var item in Model)
            {
            <tr id="row_@item.id">

                <td>@item.user_name</td>
                <td>@item.account_name</td>
                <td>@item.account_code</td>
                <td>@FunctionSupport.convertVND((decimal)item.total, " - VND")</td>
                @if (item.status == 1)
                {
                    <td><span class="label label-success">Đã thanh toán</span></td>
                }
                else
                {
                    <td><span class="label label-danger">Đang xử lý</span></td>
                }
                <td>@item.created_at</td>
                <td><a href='javascript:window.location.reload();' class="btn-active" data-id="@item.id">@Html.Raw(item.status == 1 ? "<strong>Xác nhận</strong>" : "")</a></td>
            </tr>
            }
        </tbody>
    </table>
    <div>
        @Html.PagedListPager(Model, page => Url.Action("Withdrawl", new { page, @searchString = @ViewBag.SearchString, @status = @ViewBag.status }))
    </div>
</div>